--------------------------------------------------------------------------------------------------
-- AutoLuaBind is used for bind c/c++ lib to lua.
-- it is a tool which is like tolua++, and it's base on luabind.
-- Actually, AutoLuaBind is an C/C++ code parser.
-- Auther: lixinyiabc123@gmail.com
--------------------------------------------------------------------------------------------------

--------------------------------------- EXAMPLE CODE ---------------------------------------
--local ogrePath = 'D:/SDK/Ogre/Src/OgreMain/include';
--local ceguiPath = 'D:/SDK/CEGUI/cegui/include';
--
----
--setting('C', false);
--
----Ogre
--setting('MACRO', {'_OgreExport', 'CALLBACK', 'FORCEINLINE', 'OGRE_MUTEX%s-%b()', 'OGRE_AUTO_MUTEX%s-%b()', 'OGRE_STATIC_MUTEX%s-%b()'});
--setting('functionFilter', generalFunctionFilter);
--setting('variableFilter', generalVariableFilter);
--parseDir(ogrePath);
--
----CEGUI
--setting('MACRO', 'CEGUIEXPORT');
--setting('functionFilter', nil);
--setting('variableFilter', nil);
--parseDir(ceguiPath, true);
--
----ToLuaBind
--luabind('OgreLuaLib', './OgreLuaLib.h', 'Ogre');
--luabind('CEGUILuaLib', './CEGUILuaLib.h', 'CEGUI');
--------------------------------------- EXAMPLE CODE ---------------------------------------

--ռ·
nsPath = {};
nsIndex = 0;
gTablePath = {};
gCodeTable = {};
gParamList = {};    --

--ȫֳ
gDefaultNS = 'global';  --Ĭռ
gDefaultClass = 'null';     --Ĭ
nameRule = '[%a_]+[%w_]*';  --ʽ

--ò
-- C ǷC롣true/false
-- MACRO ָĺ궨塣ַ  ַ
-- functionFilterοgeneralFunctionFilter()
-- variableFilterοgeneralVariableFilter()
function setting(key, val)
    if gParamList == nil then
        gParamList = {};
    end
    gParamList[key] = val;
end

--
function info()    
    print('Settings:');
    print('------------------------------------');
    for key, var in pairs(gParamList) do
        if type(var) == 'table' then
            print(key .. '\n');
            for k, v in pairs(var) do
                print('\t', k,v);
            end
        else
            print(key, var);
        end           
    end
    print('------------------------------------\n');
end

--
function clear()
    nsPath = {};
    nsIndex = 0;
    gTablePath = {};
    gCodeTable = {};
    
    gParamList = nil;
end

--Ԥ
function preprocess(code)
    --ȥע
    code = string.gsub(code, '//%C*' , '');
    code = string.gsub(code,'/%*.-%*/', '');
    --ȥ
    code = string.gsub(code, '#.-\n', '');
    --ȥ궨
    macro = gParamList['MACRO'];
    if macro ~= nil then
        if type(macro) == 'string' then
            code = string.gsub(code, macro, '');
        elseif type(macro) == 'table' then
            for index, def in ipairs(macro) do
                code = string.gsub(code, def, '');
            end
        end
    end    
    
    code = string.gsub(code, 'virtual%s+', '');
    code = string.gsub(code, 'explicit%s+', '');
    code = string.gsub(code, 'inline%s+', '');
    code = string.gsub(code, 'friend%s+class.-;', '');      --Ԫ 
    code = string.gsub(code, 'friend%s+', '');      --Ԫ
    
    --typedef
    code = code:gsub('typedef.-;', '');
    code = code:gsub('template.-%b<>.-%b{};?', '');    
    code = code:gsub('union.-%b{};', '');
    return code;
end

--ͨú'_'ͷĺ
function generalFunctionFilter(name)
    if name == nil then
        return false;
    end
    if name:sub(1,1) == '_' then
        --print('function filter: ', name);
        return false;
    else
        return true;
    end
end

--ͨú'm'ͷĺ
function generalVariableFilter(name)
    if name == nil then
        return false;
    end
    if name:sub(1,1) == 'm' then
        return false;
    else
        return true;
    end
end

--һns
function NextNS(name)
    local nsTable;
    if nsIndex == 0 then
        --ռ
        nsTable = gCodeTable[name];
    else
        --ռ
        if gTablePath[nsIndex].child ~= nil then
            nsTable = gTablePath[nsIndex].child[name];
        end 
    end
    
    nsIndex = nsIndex + 1;
    if nsTable == nil then
        nsTable = {};
        nsTable.name = name;
        nsTable.index = nsIndex;
        nsTable.parent = nil;
        nsTable.child = nil;
    end
    nsPath[nsIndex] = name;     --¼ǰռ
    gTablePath[nsIndex] = nsTable;  --¼ǰ
end

--صǰһns
function PreNS()
    --鵱ǰռ䶨, ж壬洢    
    local nsTable = gTablePath[nsIndex];        
    if  nsTable['constructor'] ~= nil or nsTable['deconstructor'] ~= nil or
        nsTable['staticFunction'] ~= nil or nsTable['memberFunction'] ~= nil or 
        nsTable['staticVariable'] ~= nil or nsTable['memberVariable'] ~= nil or 
        nsTable['base'] ~= nil or nsTable.child ~= nil then
        
        --ռж壬洢
        local nsParent;
        if nsIndex > 1 then
            --ǰΪռ
            nsParent = gTablePath[nsIndex-1];
            if nsParent.child == nil then
                nsParent.child = {};
            end
            nsParent.child[nsTable.name] = nsTable;
            nsTable.parent = nsParent;
        else
            --ǰΪռ
            gCodeTable[nsTable.name] = nsTable;
            nsTable.parent = nil;        
        end
    end
    nsIndex = nsIndex - 1;    
end

--
function def(name, defTable, unique)    
    local nsTable = gTablePath[nsIndex][name];    
    if nsTable == nil then
        nsTable = {};
        gTablePath[nsIndex][name] = nsTable;
    end
    
    if unique == nil then
        nsTable[#nsTable+1] = defTable; --ʺϹ캯
        return;
    end
    
    --Ψһ, Ϊǽ
    if unique == true then
        local funcTable = nsTable[defTable.name];
        if funcTable == nil then
            funcTable = {};     
            nsTable[defTable.name] = funcTable;       
        end
        funcTable[#funcTable+1] = defTable; --ʺϺ
    else
        nsTable[defTable.name] = defTable;  --Ѷ,  ʺϱ
    end
end

--ȡһ
function getLastWord(str)
    local tmp = str:reverse();
    tmp = tmp:match('([%w_]*[%a_]+)');
    return tmp:reverse();
end

--ȥǰַ
function trim(s)
    return s:match('^()%s*$') and '' or s:match('^%s*(.*%S)');
end

--
function parseVar(code, asList)
    local varType, varName, static;
    code, cnt = code:gsub('static%s+', '');
    if cnt > 0 then
        static = true;
    else
        static = false;
    end
    
    code = code:gsub('const%s+', '__CONST__');
    code = code:gsub('unsigned%s+', '__UNSIGNED__');
    code = code:gsub('%s-::%s-', '___NS___');
    code = code:gsub('%s-=.*', '');
    
    i, j = code:find('%s-%b<>%s-');
    if i ~= nil then
        local tmp = code:sub(i,j);
        tmp = tmp:gsub('%s+', '');
        tmp = tmp:gsub(',', '__SEP__');
        tmp = tmp:gsub('*', '__POINT__');
        code = code:sub(1, i-1) .. tmp .. code:sub(j+1);
    end
    --ȡ
    i, j = code:find('[%a_][%w_<>]*');
    if i == nil then
        print('BAD VARIABLE');
        return;
    else
        varType = code:sub(i,j);
    end
    --ȡָ
    local m, n = code:find('[%*&]+', j+1);
    if m ~= nil then
        varType = varType .. code:sub(j+1, n);
    else
        n = j;
    end
    
    local nameStr = code:sub(n+1) .. ',';
    local nameList = {};
    for name in nameStr:gmatch('(' .. nameRule .. ')%s-,') do
        nameList[#nameList+1] = name;
    end

    varType = varType:gsub('__CONST__', 'const ');
    varType = varType:gsub('__UNSIGNED__', 'unsigned ');
    varType = varType:gsub('___NS___', '::');
    varType = varType:gsub('__POINT__', '*');
    varType = varType:gsub('__SEP__', ',');  
    
    varName = '';
    if asList == true then
        varName = nameList;
    elseif #nameList > 0 then
        varName = nameList[1];
    end    
    return varType, varName, static;
end


--Ҫǰ󱻣Χ, زб
function parseParam(code)
    if code == nil then
        return nil;
    end
    --ţӣ
    code = code:sub(2,-2) .. ',';
    
    local paramList = {};
    for var in code:gmatch('(%S.-),') do
        paramList[#paramList+1] = parseVar( var );
    end
   return paramList;
end


function List2String(list, sep)
    if list == nil then
        return '';
    else
        return table.concat(list, sep);
    end
end

--ÿд
function parseCodeLine(code)
    --ǰռ
    local nsTable = gTablePath[nsIndex];
    local defTable = {};
    local className = nsPath[nsIndex];
    
    --enum
    enumName, enumItems = code:match('enum%s+(' .. nameRule .. ').-(%b{})');
    --print('MATCH ENUM RESULT: ' , enumName, trim(code));
    if enumName ~= nil and enumItems ~= nil then
        ---------------------ENUM-----------------------------------------
        defTable.name = enumName;
        defTable.itemList = {};
        ---------------------------------------------------------------------
        for item in enumItems:gmatch('(' .. nameRule .. ').-%c') do
            defTable.itemList[#defTable.itemList+1] = item;
        end
        def('enum', defTable, false);    -- name - defTable
    
        --print('enum ' .. enumName .. '\n{\n');
        --for item in enumItems:gmatch('(' .. nameRule .. ').-%c') do
            --print('\t' .. item .. ',\n');
        --end
        --print('};');
        return '';
    end
    

    --жǷ
    local funcPrefix, funcParam, funcSuffix = code:match('(.-)(%b())(.-)');
    if funcPrefix ~= nil then
        --б
        paramList = parseParam(funcParam);        
        --        
        local retValue, funcName, isStatic = parseVar(funcPrefix);

        --֧Ԫ͵Ĳ
        if funcPrefix:find('operator') then
            --غ
            if #paramList == 1 then
                local opt = funcPrefix:match('operator%s-(%p+)');
                if opt == '+' or opt == '-' or opt == '*' or opt == '/' or opt == '==' or opt == '<' or opt == '<='  then
                    defTable.name = opt;
                    defTable.param = paramList;  
                    def('operator', defTable, true);                    
                end
            end
            return '';
        end
        
        if funcName == nil or funcName == '' then
            -----------------CONSTRUCTOR--------------------------------
            defTable.name = className;
            defTable.param = paramList;               
            -------------------------------------------------------------------
            --Լ 캯  
             -- or funcPrefix:find(className)
            if funcPrefix:find('~' .. className) then                         
                def('deconstructor', defTable);  --   index - defTable
                --print(prefix .. '~' .. className  .. '(' .. List2String(paramList, ', ') .. ')');
                return '';
            end
           
           --캯
           if funcPrefix:find( className) then 
                def('constructor', defTable);  -- index - defTable
                --print(prefix .. className  .. '(' .. List2String(paramList, ', ') .. ')');
                return '';
            end       

            print('/*------------------------BAD FUNCTION:---------------------------------');
            print('CLASS:          ' .. className);
            print('CODELINE:   ' .. trim(code));
            print('----------------------------------------------------------------------------*/');
            return '';
    
        else
            --
            functionFilter = gParamList['functionFilter'];
            if functionFilter ~= nil and functionFilter(funcName) == false then
                return '';
            end
        
            ------------------------FUNCTION----------------------------------------------
            defTable.name = funcName;
            defTable.param = paramList;     
            defTable.retValue = retValue;
            ----------------------------------------------------------------------------------
            
            if isStatic == true then
                --̬
                def('staticFunction', defTable, true);  -- name - {defTable}
            else
                --ͨ
                def('memberFunction', defTable, true);   -- name - {defTable}
            end        
            --print(prefix .. retValue .. ' '.. funcName .. '(' .. List2String(paramList, ', ') .. ')');
            return '';
        end
    end
    
    --, ܻö,  int a,b;
    varType, varName, isStatic = parseVar(code, true);
    if varType ~= nil and varName ~= nil and #varName > 0 then
        for index, name in ipairs(varName) do
            ---------------VARIABLE--------------------------------------------
            defTable = {};
            defTable.name = name;
            defTable.type = varType;
            ----------------------------------------------------------------------
            variableFilter = gParamList['variableFilter'];
            if variableFilter ~= nil and variableFilter(name) == false then
                return '';
            end                        
            if isStatic == true then
                def('staticVariable', defTable);     --  name - defTable
            else
                def('memberVariable', defTable);     --  name - defTable
            end
        end
        return '';
    end
    
    print('/*------------------------BAD DEFINATION---------------------------------');
    print('CLASS:          ' .. className);
    print('CODELINE:   ' .. trim(code));
    print('----------------------------------------------------------------------------*/');
    return '';
end

function parseBase(code)
    if code == nil then
        return ;
    end    
    code = code:gsub('public%s+', '');
    code = code:gsub('protected%s+', '');
    code = code .. ',';

    local defTable = {};
    for base in code:gmatch('(.-),') do
        base = trim(base);
        defTable[#defTable+1] = base;
    end
    if #defTable > 0 then
        def('base', defTable);
    else
        print('/*--------------------------------------------------------');
        print('NO BASE CLASS FOUND');
        print('CLASS:' .. nsPath(nsIndex));
        print('CODE:' .. trim(code));
        print('--------------------------------------------------------*/');
    end
end

function parseClassHeader(code)
    local base;
    local className;
    local index = code:find(':');
    if index ~= nil then
        base = code:sub(index+1);
        code = code:sub(1, index-1);            
    end
    
    className = getLastWord(code);
    return className, base;    
end


--
function parseClass(type, name, code, base)
    if base == nil then
        --ͷ, Ҫͷ
        name, base = parseClassHeader(name);
    else
        name = trim(name);
    end
    --ռ
    NextNS(name);   
    --
    parseBase(base);    
    --ɾ {};
    code = code:sub(2,-3);

    --ڲ
    local innerClassList = {};
    
    --ڲ
    function getPublicInnerClass(header, def)
        local name, base = parseClassHeader(header);    
        classTable = {};        
        classTable.name = name;
        classTable.def = def;
        classTable.base = base;
        innerClassList[name] = classTable;
        return 'class ' .. name .. '{};';
    end
    code = code:gsub('class%s+(.-)(%b{};)', getPublicInnerClass);
    
    --зǹ
    code = code:gsub('protected:.-public:', '');
    code = code:gsub('private:.-public:', '');
    code = code:gsub('private:.*', '');
    code = code:gsub('protected:.*', '');
    code = code:gsub('public:', '');
    
    function processInnerClass(className)
        local classTable = innerClassList[className];
        parseClass('class', classTable.name, classTable.def, classTable.base);
        return '';
    end
    --ȡpublicڲ
    code = code:gsub('class%s+(' .. nameRule .. ')%s-%b{};', processInnerClass);
    innerClassList = nil;
    
    --ڲṹ
    code = code:gsub('%s+(struct)(.-)(%b{};)', parseClass);
            
    --ÿд
    code = code:gsub('(.-);', parseCodeLine);
    PreNS();
    return '';
end

--ռ
function parseNamespace(name, code)
    NextNS(name);    
    --ǰ
    code = code:gsub('(class[^{}]-;)', '');   
    --ʵִ
    code = code:gsub('[\n%s]-%b{}[^;]', ';\n');    
    --ṹ
    code = code:gsub('%s+(class)(.-)(%b{};)', parseClass);
    code = code:gsub('%s+(struct)(.-)(%b{};)', parseClass);
    
    if gParamList['C'] == true then
        --ÿд, Ĭ϶һ, зԼΪ̬
        parseClass('DEFAULT_CLASS', gDefaultClass, code);
    end
    
    PreNS();
    return '';
end

--
function parseCode(code)    
    code = preprocess(code);
    code = string.gsub(code, '%s+namespace%s+(' .. nameRule .. ')%s-(%b{})', parseNamespace);
    --ȫֿռĴ
    parseNamespace(gDefaultNS, code);
end

--Դļ
function parseFile( path )
    file = io.open(path, 'r');
    if file == nil then
        print('Can not find file: ' .. path);
        return;
    end
    code = file:read('*all');
    print(os.date('%X'), 'parsing ' .. path );
    parseCode(code);    
end


--Ŀ¼Ŀ¼еļ
-- Ŀ¼·ǷĿ¼
function parseDir(dir_path, process_child)
    require('lfs');
    if dir_path == nil or dir_path == '' then
        print('Enter Dir Path!');
        return;
    end
    
    if process_child == nil then
        process_child = false;
    end
    
    for file in lfs.dir(dir_path) do
        if file ~= "." and file ~= ".." then        
        local f = dir_path..'/'..file;
        local attr = lfs.attributes(f);
        assert (type(attr) == "table")
        if attr.mode == "directory" then
            if process_child == true then
                parseDir(f);
            end
        else
            if f:find('.h') or f:find('.hpp') then
                parseFile(f);
            end            
    	 end
     end
  end
end

--------------------------------------LUABIND--------------------------------------------------------------------------------
function getNSList(t)
    local index = t.index;
    local ns = {};
    local parent = t;
    while parent ~= nil do
        ns[index] = parent.name;
        parent = parent.parent;
        index = index-1;
    end
    return ns;
end

function getNSPath(t)
    local ns = getNSList(t);
    return table.concat(ns, '_');
end

function getFullName(t, startIndex)
    local ns = getNSList(t);
    local name = {};
    if startIndex == nil then
        startIndex = 1;
    end
    
    for i = startIndex, #ns do
        if ns[i] ~= gDefaultNS and ns[i] ~= gDefaultClass then
            name[#name+1] = ns[i];
        end
    end
    return table.concat(name, '::');    
end

function mergeList(list1, list2)
    local list3 = {};
    for k, v in pairs(list1) do
        list3[#list3+1] = v;
    end
    for k, v in pairs(list2) do
        list3[#list3+1] = v;
    end
    return list3;
end


--class
-- 붨, 󶨺б,  󶨺б
function bindClass(classTable)    
    local code = {};
    local bindFuncList = {};
    local bindConstList = {};
            
    if classTable.child ~= nil then
        for childName, childTable in pairs(classTable.child) do
            --
            local def, bindFunc, bindConst = bindClass(childTable);
            code[#code+1] = def;
            bindFuncList =  mergeList(bindFuncList, bindFunc);
            bindConstList = mergeList(bindConstList,bindConst);
        end
    end
    
    local classFullName = getFullName(classTable, 2);    
    local classNamePath = getNSPath(classTable);
    local isClass, prefix;
    if classTable.name == gDefaultClass then
        isClass = false;
        prefix = '';
    else
        isClass = true;
        prefix = classFullName .. '::';
    end 
    
    --ڶ壬ʱ
    local targetFunctionName =  'def_class_' .. classNamePath .. '()';
    --code[#code+1] = 'luabind:scope ' .. targetFunctionName .. '\n';
    code[#code+1] = '\tscope ' .. targetFunctionName .. '\n';
    code[#code+1] = '\t{\n';
    code[#code+1] = '\t\treturn class_<' .. classFullName ..   '>(\"' .. classTable.name .. '\")';

    local constuctor = classTable['constructor'];
    if constructor ~= nil then        
        for index, defTable in ipairs(constructor) do
            code[#code+1] = '\n\t\t.def(constructor<' .. List2String(defTable.param, ',') .. '>())';
        end
    end

    local memberVariable = classTable['memberVariable'];
    if memberVariable ~= nil then        
        for index, defTable in ipairs(memberVariable) do
            code[#code+1] = '\n\t\t.def_readwrite(\"' .. defTable.name .. '\", &' .. prefix .. defTable.name ..  ')';
        end
    end

    local memberFunction = classTable['memberFunction'];    
    if memberFunction ~= nil then        
        for name, funcs in pairs(memberFunction) do
            if #funcs > 1 then
                for index, defTable in ipairs(funcs) do
                    code[#code+1] = '\n\t\t.def(\"' .. defTable.name .. '\", ('.. defTable.retValue ..'(' .. prefix .. '*)(' .. List2String(defTable.param, ',') .. '))&' .. prefix .. defTable.name ..  ')';
                end                
            else
                defTable = funcs[1];
                code[#code+1] = '\n\t\t.def(\"' .. defTable.name .. '\", &' .. prefix .. defTable.name ..  ')';
            end
        end
    end
    
    local operatorFunction = classTable['operator'];
    if operatorFunction ~= nil then
        for name, funcs in pairs(operatorFunction) do
            for index, defTable in ipairs(funcs) do                            
                local opt = defTable.name;
                local param1 = defTable.param[1]:gsub('const%s+', '');
                param1 = param1:gsub('&', '');
                code[#code+1] = '\n\t\t.def( self '.. defTable.name .. ' other<' .. param1 .. '>)';
            end     
        end
    end

    local enum = classTable['enum'];
    if enum ~= nil then
        for name, defTable in pairs(enum) do
            code[#code+1] = '\n\t\t.enum_(\"' .. name .. '\")\n';
            code[#code+1] = '\t\t[\n';
            local tmp = {};
            for index, item in pairs(defTable.itemList) do
                tmp[#tmp+1] = '\t\t\tvalue(\"' .. item .. '\", ' .. prefix .. item .. ')';
            end
            code[#code+1] = table.concat(tmp, ',\n');
            code[#code+1] = '\n\t\t]';
        end
    end
    
    if isClass == false then
        --
        local memberFunction = classTable['memberFunction'];    
        local staticFunction = classTable['staticFunction'];
        if memberFunction ~= nil then        
           if staticFunction == nil then
                classTable['staticFunction'] = memberFunction;
           else
                for name, funcs in pairs(staticFunction) do
                    staticFunction[name] = funcs;
                end
           end
        end    
    end

    local staticFunction = classTable['staticFunction'];
    if staticFunction ~= nil then
        for name, funcs in pairs(staticFunction) do
            if #funcs > 1 then
                for index, defTable in pairs(funcs) do
                    bindFuncList[#bindFuncList+1] = 'def(\"' .. defTable.name .. '\", ('.. defTable.retValue ..'(' .. prefix .. '*)(' .. List2String(defTable.param, ',') .. '))&' .. classFullName .. defTable.name ..  ')';
                end
            else
                defTable = funcs[1];
                bindFuncList[#bindFuncList+1] = 'def(\"' .. defTable.name .. '\", &' .. prefix .. defTable.name ..  ')';
            end
        end
    end
    
    --ӿռ󶨾̬
    if #bindFuncList > 0 then
        code[#code+1] = '\n\t\t.scope\n\t\t[\n\t\t\t';
        code[#code+1] = table.concat(bindFuncList, ',\n\t\t\t');
        code[#code+1] = '\n\t\t]';        
    end
    code[#code+1] = ';';
    code[#code+1] = '\n\t}\n\n';    
    
    if isClass == false then
        code = {};
    else
        bindFuncList = {};
        bindFuncList[1] = targetFunctionName;
    end
    
    --
    local staticVariable = classTable['staticVariable'];
    if staticVariable ~= nil then
        local constFuncName = 'def_static_const_' .. classNamePath .. '()';        
        code[#code+1] = '\tvoid ' .. constFuncName .. '\n\t{\n';        
        code[#code+1] = '\t\tobject env = globals(mState)';
        local ns = getFullName(classTable) .. '::';
        for name in ns:gmatch('(%a+%w-)::') do
            code[#code+1] = '[\"' .. name .. '\"]'
        end
        code[#code+1] = ';\n';                
        for index, defTable in ipairs(staticVariable) do
            code[#code+1] = '\t\tenv[\"' .. defTable.name .. '\"] = '.. prefix  .. defTable.name .. ';\n';
        end
        code[#code+1] = '\t}\n\n';
        bindConstList[#bindConstList+1] = constFuncName;
    end

    return table.concat(code), bindFuncList, bindConstList;
end

--󶨴
--libName: Ŀ
--path: Ŀļ
--selectNS: ѡռ䡣ֵΪnilȫռ䶨塣ֵΪstring  string table
function luabind(libName, path, selectNS)
    local namespaceList = {};
    if selectNS ~= nil then
        if type(selectNS) == 'table' then
            namespaceList = selectNS;
        elseif type(selectNS) == 'string' then
            namespaceList[#namespaceList+1] = selectNS;
        end
    else
        for nsName, nsTable in pairs(gCodeTable) do
            namespaceList[#namespaceList+1] = nsName;
        end
    end
    
    --ռ䣬 кĶռ
    local str={};
    local code = {};
    str[#str+1] = '#ifndef ' .. libName:upper() .. '_LUA_INTERFACE_H\n';
    str[#str+1] = '#define ' .. libName:upper() .. '_LUA_INTERFACE_H\n';
    str[#str+1] = '#include \"lua.hpp\"\n';   
    str[#str+1] = '#include <luabind/luabind.hpp>\n';    
    str[#str+1] = 'using namespace luabind;\n';
    
    for index, nsName in ipairs(namespaceList) do
        if nsName ~= gDefaultNS then
            str[#str+1] = 'using namespace '.. nsName .. ';\n\n';
        end        
    end    
    
    str[#str+1] = 'class ' .. libName .. '\n{\n';
    str[#str+1] = 'public:\n';
    str[#str+1] = '\tvoid openLib( lua_State* L )\n\t{\n';
    str[#str+1] = '\t\tmState = L;\n';
    str[#str+1] = '\t\tmodule_(L)\n';
    str[#str+1] = '\t\t[\n';
    
    local bindCode = {};
    local bindConstFuncList = {};
    local bindNS = {};
    local tmp = {};
    
    for index, nsName in ipairs(namespaceList) do
        nsTable = gCodeTable[nsName];
        if nsTable == nil then
            print('LuaBind ERROR:','Can not find namespace: ' .. nsName);
            return;
        else
            print('luabind: ', nsName);    
        end        
        if nsName == gDefaultNS then
            nsName = ' ';
        end
        tmp = {};
        tmp[#tmp+1] = '\t\t\tnamespace_(\"' .. nsName  .. '\")\n';
        tmp[#tmp+1] = '\t\t\t[\n';
        
        local defFunc = {};
        for className, classTable in pairs(nsTable.child) do
            --print('\t', className, classTable);
            local def, bindFunc, bindConst = bindClass(classTable);
            bindCode[#bindCode+1] = def;    --
            for index, func in ipairs(bindConst) do
                bindConstFuncList[#bindConstFuncList+1] = func;
            end
            
            for index, funcName in ipairs(bindFunc) do
                defFunc[#defFunc+1] = '\t\t\t\t' .. funcName; 
            end
        end
        tmp[#tmp+1] = table.concat(defFunc, ',\n');
        tmp[#tmp+1] = '\n\t\t\t]';
        bindNS[#bindNS+1] = table.concat(tmp);
    end
    str[#str+1] = table.concat(bindNS, ',\n');
    str[#str+1] = '\n\t\t];\n';
    for index, func in ipairs(bindConstFuncList) do
        str[#str+1] = '\t\t' .. func .. ';\n';
    end

    str[#str+1] = '\t}\n\n';
    str[#str+1] = 'private:\n';
    str[#str+1] = '\tlua_State* mState;\n\n';
    str[#str+1] = 'private:\n';
    str[#str+1] = table.concat(bindCode,'\n');    
    local code = table.concat(str);
    
    --
    if path ~= nil then
        file = io.open(path, 'w');
        if file == nil then
            print('Failed', 'Can\'t create file: ' .. path .. ' !!!');
            return code;
        end
        file:write(code);
        file:close();
        print('OK', 'Lib:', libName, 'Path:', path);
    end
    return code;    
end
